DECLARE SUB MKMD (D$)
DECLARE FUNCTION DRIVES$ ()
DECLARE FUNCTION DINPUT$ (TEXT$, ORIG$)
DECLARE FUNCTION REVI% (S$, L$)
DECLARE FUNCTION MAIN% ()
DECLARE FUNCTION INSTALL% ()
DECLARE FUNCTION SMODE% ()
DECLARE FUNCTION CSCHEME% ()
DECLARE FUNCTION FINPUT$ (VALID$, MLEN%, DEF$)
DECLARE SUB CSMENU (n$, BR%, BG%, BB%, TR%, TG%, TB%)
DECLARE SUB SMHPAL (F%, T%, FR%, FG%, FB%, TR%, TG%, TB%)
DECLARE SUB SETPAL (A%, R%, G%, B%)
DECLARE SUB CENTERG (R%, C%, TXT$)
DECLARE SUB CUSTOM (DNAM$)
DECLARE SUB CENTER (R%, C%, TXT$)
DECLARE SUB BORDER (X%, W%, y%, H%, C%)

'** ERROR HANDLER
ON ERROR GOTO UE

'** NEEDED FOR ANDREW GIBSONS DRIVES$ ROUT
TYPE RegType
 AX AS INTEGER: BX AS INTEGER: CX AS INTEGER: DX AS INTEGER
 BP AS INTEGER: SI AS INTEGER: DI AS INTEGER: F  AS INTEGER
END TYPE
DIM SHARED Regs AS RegType, ERRX%

TYPE CSCHEME
 BR AS INTEGER: BG AS INTEGER: BB AS INTEGER
 TR AS INTEGER: TG AS INTEGER: TB AS INTEGER
END TYPE
DIM SHARED SCRMOD%
DIM SHARED CCS AS CSCHEME
CLS : WIDTH 80, 25
ON ERROR GOTO FC
OPEN "MCD.CFG" FOR INPUT AS #1: CLOSE #1
ON ERROR GOTO UE
IF ERRX% THEN X% = INSTALL

OPEN "MCD.CFG" FOR BINARY ACCESS READ AS #1
IF LOF(1) = 1 THEN
 X$ = CHR$(0): GET #1, , X$
 IF X$ <> CHR$(0) THEN PRINT "CFG FILE ERROR!": END
 PRINT "This copy of MCD has just been installed!"
 PRINT "Please run MCD to create a new configuration file!"
 END
END IF
SEEK #1, 3: GET #1, , CCS
CLOSE #1
DO
 SELECT CASE n%
  CASE 0: n% = MAIN
  CASE 1: n% = INSTALL
  CASE 2: n% = SMODE
  CASE 3: n% = CSCHEME
  CASE 4
   OPEN "MCD.CFG" FOR BINARY ACCESS WRITE AS #1
   SEEK #1, 3: PUT #1, , CCS
   CLOSE #1
   CLS : END
  CASE 9
   CLS : END
 END SELECT
LOOP
FC:
 ERRX% = ERR
 RESUME NEXT
UE:
 CLS
 PRINT "MCDSETUP: ERROR!"
 PRINT " * ";
 SELECT CASE ERR
  CASE 7: PRINT "Out of memory!"
  CASE 14: PRINT "Out of string space!"
  CASE 52, 64: PRINT "Bad filename!"
  CASE 53: PRINT "File not found!"
  CASE 55, 70, 75: PRINT "Can't open file!"
  CASE 61: PRINT "Disk full!"
  CASE 67: PRINT "Too many files!"
  CASE 70: PRINT "Permission denied!"
  CASE 71: PRINT "Disk not ready!"
  CASE 72: PRINT "Disk media error!"
  CASE 76: PRINT "Path not found!"
  CASE ELSE: PRINT "Unknown error!"
 END SELECT
 END
SRC:
 DATA 9,2
 DATA MCD.MAK
 DATA MCD.BAS
 DATA MCDM.BAS
 DATA MCDC.BAS
 DATA MCD.DAT
 DATA MCD.CON
 DATA MCD.TXT
 DATA MCD2WAV.BAS
 DATA MCDSETUP.BAS
EXE:
 DATA 6,2
 DATA MCD.EXE
 DATA MCD.DAT
 DATA MCD.CON
 DATA MCD.TXT
 DATA MCD2WAV.EXE
 DATA MCDSETUP.EXE
CMN:
 DATA MCD.CFG,1
 DATA 0

 DATA SETUP.CFG,245
 DATA 11,0,8,0,33,68,69,70,65,85,76,84,62,0,62,0,62,0,22,0,22,0,62,0,5,0,66
 DATA 69,65,67,72,62,0,62,0,16,0,0,0,16,0,62,0,5,0,71,82,65,83,83,4,0,62,0,16
 DATA 0,6,0,44,0,24,0,15,0,73,78,67,82,69,68,73,66,76,69,32,72,85,76,75,0,0
 DATA 62,0,0,0,0,0,62,0,44,0,10,0,76,73,71,72,84,32,66,85,76,66,62,0,62,0,0
 DATA 0,62,0,62,0,0,0,7,0,77,79,78,83,84,69,82,46,0,62,0,26,0,62,0,22,0,22,0
 DATA 5,0,78,73,71,72,84,0,0,22,0,42,0,18,0,18,0,34,0,12,0,80,73,78,75,32,80
 DATA 65,78,84,72,69,82,62,0,22,0,42,0,62,0,0,0,26,0,5,0,82,79,83,69,83,62,0
 DATA 18,0,32,0,62,0,16,0,24,0,10,0,83,84,79,82,77,89,32,83,69,65,40,0,40,0
 DATA 62,0,30,0,28,0,62,0,7,0,86,73,79,76,69,84,83,62,0,18,0,62,0,62,0,18,0
 DATA 62,0

SUB BORDER (X%, W%, y%, H%, C%)
 COLOR C%
 LOCATE y%, X%: PRINT "+" + STRING$(W% - 2, "-") + "+"
 FOR n% = y% + 1 TO y% + H% - 2
  LOCATE n%, X%: PRINT "|"
  LOCATE n%, X% + W% - 1: PRINT "|"
 NEXT n%
 LOCATE y% + H% - 1, X%: PRINT "+" + STRING$(W% - 2, "-") + "+"
END SUB

SUB CENTER (R%, C%, TXT$)
 LOCATE R%, 40 - LEN(TXT$) \ 2: COLOR C%: PRINT TXT$
END SUB

SUB CENTERG (R%, C%, TXT$)
 LOCATE R%, 21 - LEN(TXT$) \ 2: COLOR C%: PRINT TXT$
END SUB

SUB CHDRV (DRIVE$)
 Regs.AX = &HE00
 Regs.DX = ASC(UCASE$(DRIVE$)) - 64
 CALL Interrupt(&H21, Regs, Regs)
END SUB

FUNCTION CSCHEME%
 CLS
 CENTER 9, 12, "COLOR SCHEMES!"
 CENTER 20, 9, "press escape to cancel selection"
 BORDER 24, 32, 8, 8, 10
 COLOR 15
 DIM CSN(255) AS STRING
 DIM CSV(1 TO 255) AS CSCHEME
 OPEN "SETUP.CFG" FOR BINARY ACCESS READ AS #1
 GET #1, , MAX%
 IF MAX% > 255 THEN MAX% = 255
 FOR n% = 1 TO MAX%
  GET #1, , L%: CSN(n%) = SPACE$(L%)
  GET #1, , CSN(n%): GET #1, , CSV(n%)
 NEXT n%
 CLOSE #1
 CSN(0) = "[ CUSTOM ]"
 FOR n% = 1 TO MAX%
  IF CSV(n%).BR = CCS.BR AND CSV(n%).BG = CCS.BG THEN
   IF CSV(n%).BB = CCS.BB AND CSV(n%).TR = CCS.TR THEN
    IF CSV(n%).TG = CCS.TG AND CSV(n%).TB = CCS.TB THEN
     ROW% = n%
     EXIT FOR
    END IF
   END IF
  END IF
 NEXT n%
 START% = ROW% - 1
 IF START% > MAX% - 3 THEN START% = MAX% - 3
 IF START% < 0 THEN START% = 0
 DO
  FOR n% = 0 TO 3
   CENTER n% + 11, 14, SPACE$(20)
   CENTER n% + 11, 14, CSN(n% + START%)
  NEXT n%
  COLOR 15
  LOCATE ROW% - START% + 11, 29: PRINT "<"
  LOCATE ROW% - START% + 11, 50: PRINT ">"
  IN$ = "": WHILE IN$ = "": IN$ = INKEY$: WEND
  LOCATE ROW% - START% + 11, 29: PRINT " "
  LOCATE ROW% - START% + 11, 50: PRINT " "
  SELECT CASE IN$
   CASE CHR$(0) + "H"
    IF ROW% > 0 THEN ROW% = ROW% - 1
    IF ROW% - START% < 0 THEN START% = START% - 1
   CASE CHR$(0) + "P"
    IF ROW% < MAX% THEN ROW% = ROW% + 1
    IF ROW% - START% > 3 THEN START% = START% + 1
   CASE CHR$(13)
    IF ROW% = 0 THEN
     D$ = ""
     CUSTOM D$
     WIDTH 80, 25
     CSCHEME% = 3
     IF D$ = "" THEN CSCHEME% = 0
     EXIT FUNCTION
    ELSE
     CSMENU CSN(ROW%), CSV(ROW%).BR, CSV(ROW%).BG, CSV(ROW%).BB, CSV(ROW%).TR, CSV(ROW%).TG, CSV(ROW%).TB
    END IF
    CSHEME% = 0
    IF CSN(ROW%) = CHR$(0) THEN CSCHEME% = 3
    EXIT FUNCTION
   CASE CHR$(27)
    CSCHEME% = 0: EXIT FUNCTION
  END SELECT
 LOOP
END FUNCTION

SUB CSMENU (n$, BR%, BG%, BB%, TR%, TG%, TB%)
 DN$ = n$
CSMENUS:
 CLS
 CENTER 9, 12, n$
 CENTER 11, 14, "use scheme"
 CENTER 12, 14, "edit scheme"
 CENTER 13, 14, "delete scheme"
 CENTER 20, 9, "press escape to cancel"
 BORDER 24, 32, 8, 8, 10
 COLOR 15
 DO
  LOCATE ROW% + 11, 27: PRINT "<"
  LOCATE ROW% + 11, 52: PRINT ">"
  IN$ = "": WHILE IN$ = "": IN$ = INKEY$: WEND
  LOCATE ROW% + 11, 27: PRINT " "
  LOCATE ROW% + 11, 52: PRINT " "
  SELECT CASE IN$
   CASE CHR$(0) + "H"
    IF ROW% > 0 THEN ROW% = ROW% - 1
   CASE CHR$(0) + "P"
    IF ROW% < 2 THEN ROW% = ROW% + 1
   CASE CHR$(13)
    SELECT CASE ROW%
     CASE 0
      CCS.BR = BR%: CCS.BG = BG%: CCS.BB = BB%
      CCS.TR = TR%: CCS.TG = TG%: CCS.TB = TB%
      EXIT SUB
     CASE 1
      BRT% = CCS.BR: BGT% = CCS.BG: BBT% = CCS.BB
      TRT% = CCS.TR: TGT% = CCS.TG: TBT% = CCS.TB
      CCS.BR = BR%: CCS.BG = BG%: CCS.BB = BB%
      CCS.TR = TR%: CCS.TG = TG%: CCS.TB = TB%
      ON$ = n$
      CUSTOM n$
      WIDTH 80, 25
      IF n$ = CHR$(0) THEN
       CCS.BR = BRT%: CCS.BG = BGT%: CCS.BB = BBT%
       CCS.TR = TRT%: CCS.TG = TGT%: CCS.TB = TBT%
       n$ = ON$
      ELSE
       BR% = CCS.BR: BG% = CCS.BG: BB% = CCS.BB
       TR% = CCS.TR: TG% = CCS.TG: TB% = CCS.TB
       IF n$ = "" THEN
        n$ = ON$
        IF RIGHT$(n$, 1) <> ")" THEN n$ = n$ + "(EDITED)"
       END IF
      END IF
      GOTO CSMENUS
     CASE 2
      DIM CSN(1 TO 255) AS STRING
      DIM CSV(1 TO 255) AS CSCHEME
      OPEN "SETUP.CFG" FOR BINARY ACCESS READ AS #1
      GET #1, , MAX%
      IF MAX% > 255 THEN MAX% = 255
      FOR n% = 1 TO MAX%
       GET #1, , L%: CSN(n%) = SPACE$(L%)
       GET #1, , CSN(n%): GET #1, , CSV(n%)
      NEXT n%
      CLOSE #1
      MAX% = MAX% - 1
      OPEN "SETUP.CFG" FOR OUTPUT AS #1: CLOSE #1
      OPEN "SETUP.CFG" FOR BINARY ACCESS WRITE AS #1
      PUT #1, , MAX%
      FOR n% = 1 TO MAX% + 1
       IF CSN(n%) <> DN$ THEN
        L% = LEN(CSN(n%)): PUT #1, , L%
        PUT #1, , CSN(n%): PUT #1, , CSV(n%)
       END IF
      NEXT n%
      CLOSE #1
      n$ = CHR$(0)
      EXIT SUB
    END SELECT
   CASE CHR$(27)
    n$ = CHR$(0)
    EXIT SUB
  END SELECT
 LOOP
END SUB

SUB CUSTOM (DNAM$)
 DIM C(5) AS INTEGER
 C(0) = (CCS.BR \ 2) * 2: C(1) = (CCS.BG \ 2) * 2: C(2) = (CCS.BB \ 2) * 2
 C(3) = (CCS.TR \ 2) * 2: C(4) = (CCS.TG \ 2) * 2: C(5) = (CCS.TB \ 2) * 2
 SCREEN 13
 FOR n% = 0 TO 255
  SETPAL n%, 0, 0, 0
 NEXT n%
 CENTERG 1, 128, "BODY COLOR": CENTERG 6, 128, "TEXT COLOR"
 LOCATE 18, 16: PRINT "PRESS ENTER WHEN DONE!"
 LOCATE 19, 16: PRINT "S TO SAVE SCHEME!"
 LOCATE 20, 16: PRINT "ESC ABORTS!"
 LINE (158, 9)-(160, 13), 129, BF
 LINE (158, 17)-(160, 21), 130, BF
 LINE (158, 25)-(160, 29), 131, BF
 LINE (158, 49)-(160, 53), 132, BF
 LINE (158, 57)-(160, 61), 133, BF
 LINE (158, 65)-(160, 69), 134, BF
 OPEN "MCD.DAT" FOR BINARY ACCESS READ AS #1
 X$ = CHR$(0)
 SEEK #1, 112811
 FOR y% = 1 TO 92
  FOR X% = 1 TO 64
   GET #1, , X$
   PSET (X% + 32, y% + 100), ASC(X$)
  NEXT X%
 NEXT y%
 CLOSE #1
 SETPAL 128, 63, 63, 63
 SETPAL 129, 63, 15, 15: SETPAL 130, 15, 63, 15: SETPAL 131, 15, 15, 63
 SETPAL 132, 63, 15, 15: SETPAL 133, 15, 63, 15: SETPAL 134, 15, 15, 63
 DO
  FOR y% = 0 TO 5
   YP% = 8 + y% * 8 + (y% \ 3) * 16
   C% = y% + 129
   FOR X% = 0 TO 62 STEP 2
    IF X% = C(y%) THEN C% = 0
    LINE (153 - X% * 2, YP% + 1)-(155 - X% * 2, YP% + 5), C%, BF
    LINE (163 + X% * 2, YP% + 1)-(165 + X% * 2, YP% + 5), C%, BF
   NEXT X%
  NEXT y%
  SMHPAL 0, 63, 0, 0, 0, C(0), C(1), C(2)
  PNR! = (63 - C(0)) / 4: PNG! = (63 - C(1)) / 4: PNB! = C(2) / 4
  FOR n% = 0 TO 3
   PNR% = 63 - PNR! * n%: PNG% = 63 - PNG! * n%: PNB% = PNB! * n%
   SMHPAL 64 + n% * 16, 79 + n% * 16, 0, 0, 0, PNR%, PNG%, PNB%
  NEXT n%
  SMHPAL 192, 255, 0, 0, 0, C(3), C(4), C(5)
  LOCATE ROW% + 2 + (ROW% \ 3) * 2, 2: PRINT "<"
  LOCATE ROW% + 2 + (ROW% \ 3) * 2, 39: PRINT ">"
  IN$ = "": WHILE IN$ = "": IN$ = INKEY$: WEND
  LOCATE ROW% + 2 + (ROW% \ 3) * 2, 2: PRINT " "
  LOCATE ROW% + 2 + (ROW% \ 3) * 2, 39: PRINT " "
  SELECT CASE IN$
   CASE CHR$(0) + "P"
    ROW% = ROW% + 1
    IF ROW% = 6 THEN ROW% = 0
   CASE CHR$(0) + "H"
    ROW% = ROW% - 1
    IF ROW% = -1 THEN ROW% = 5
   CASE CHR$(0) + "K"
    IF C(ROW%) > 0 THEN C(ROW%) = C(ROW%) - 2
   CASE CHR$(0) + "M"
    IF C(ROW%) < 62 THEN C(ROW%) = C(ROW%) + 2
   CASE "S", "s"
    LOCATE 24, 16: PRINT "SAVE AS (ESC ABORTS)";
    LOCATE 25, 16: PRINT ": ";
    X$ = FINPUT("ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789,.-+/*#!?& ", 20, DNAM$)
    IF X$ <> CHR$(0) AND X$ <> SPACE$(LEN(X$)) THEN
     X$ = LTRIM$(RTRIM$(X$))
     DIM CSN(1 TO 255) AS STRING
     DIM CSV(1 TO 255) AS CSCHEME
     OPEN "SETUP.CFG" FOR BINARY ACCESS READ AS #1
     GET #1, , MAX%
     IF MAX% > 255 THEN MAX% = 255
     FOR n% = 1 TO MAX%
      GET #1, , L%: CSN(n%) = SPACE$(L%)
      GET #1, , CSN(n%): GET #1, , CSV(n%)
     NEXT n%
     CLOSE #1
     IF MAX% = 255 THEN
      BEEP
     ELSE
      FOR n% = 1 TO MAX%
       IF X$ = CSN(n%) THEN S% = n%
      NEXT n%
      IF S% = 0 THEN MAX% = MAX% + 1: S% = MAX%
      CSN(S%) = X$
      CSV(S%).BR = C(0): CSV(S%).BG = C(1): CSV(S%).BB = C(2)
      CSV(S%).TR = C(3): CSV(S%).TG = C(4): CSV(S%).TB = C(5)
      FOR n% = 1 TO MAX% - 1
       FOR Z% = n% + 1 TO MAX%
        IF CSN(n%) > CSN(Z%) THEN
         TN$ = CSN(n%): CSN(n%) = CSN(Z%): CSN(Z%) = TN$
         TBR% = CSV(n%).BR: TBG% = CSV(n%).BG: TBB% = CSV(n%).BB
         TTR% = CSV(n%).TR: TTG% = CSV(n%).TG: TTB% = CSV(n%).TB
         CSV(n%).BR = CSV(Z%).BR: CSV(n%).BG = CSV(Z%).BG
         CSV(n%).BB = CSV(Z%).BB: CSV(n%).TR = CSV(Z%).TR
         CSV(n%).TG = CSV(Z%).TG: CSV(n%).TB = CSV(Z%).TB
         CSV(Z%).BR = TBR%: CSV(Z%).BG = TBG%: CSV(Z%).BB = TBB%
         CSV(Z%).TR = TTR%: CSV(Z%).TG = TTG%: CSV(Z%).TB = TTB%
        END IF
       NEXT Z%
      NEXT n%
      OPEN "SETUP.CFG" FOR BINARY ACCESS WRITE AS #1
       PUT #1, , MAX%
       IF MAX% > 255 THEN MAX% = 255
       FOR n% = 1 TO MAX%
        L% = LEN(CSN(n%)): PUT #1, , L%
        PUT #1, , CSN(n%): PUT #1, , CSV(n%)
       NEXT n%
      CLOSE #1
      CCS.BR = C(0): CCS.BG = C(1): CCS.BB = C(2)
      CCS.TR = C(3): CCS.TG = C(4): CCS.TB = C(5)
      DNAM$ = X$
      EXIT SUB
     END IF
    END IF
    LOCATE 24, 16: PRINT SPACE$(20);
    LOCATE 25, 16: PRINT SPACE$(20);
   CASE CHR$(13)
    CCS.BR = C(0): CCS.BG = C(1): CCS.BB = C(2)
    CCS.TR = C(3): CCS.TG = C(4): CCS.TB = C(5)
    DNAM$ = ""
    EXIT SUB
   CASE CHR$(27)
    DNAM$ = CHR$(0)
    EXIT SUB
  END SELECT
 LOOP
 WIDTH 80, 25
 COLOR 7, 0: CLS
END SUB

FUNCTION DINPUT$ (TEXT$, ORIG$)
 VD$ = DRIVES$
 VC$ = "!#$%&'()-0123456789@ABCDEFGHIJKLMNOPQRSTUVWXYZ^_abcdef"
 VC$ = VC$ + "ghijklmnopqrsttuvwxyz{}~"
 VC$ = VC$ + ""
 LOCATE , , 1: X$ = ORIG$: PRINT TEXT$; X$;
 DO
  IN$ = "": WHILE IN$ = "": IN$ = INKEY$: WEND
  SELECT CASE IN$
   CASE CHR$(8)
    IF LEN(X$) > 0 THEN
     X$ = LEFT$(X$, LEN(X$) - 1)
     LOCATE , POS(0) - 1: PRINT " ";
     LOCATE , POS(0) - 1
    END IF
   CASE CHR$(13)
    IF LEN(X$) > 3 THEN
     IF RIGHT$(X$, 1) = "." THEN
      X$ = LEFT$(X$, LEN(X$) - 1)
      LOCATE , POS(0) - 1: PRINT " ";
      LOCATE , POS(0) - 1
      SOUND 100, 1
     ELSE
      IF RIGHT$(X$, 1) <> "\" THEN
       X$ = X$ + "\"
       PRINT "\";
       SOUND 100, 1
      ELSE
       LOCATE , , 0: DINPUT$ = X$: EXIT FUNCTION
      END IF
     END IF
    END IF
   CASE CHR$(27)
    LOCATE , , 0: DINPUT$ = "": EXIT FUNCTION
   CASE ELSE
    IN$ = UCASE$(IN$)
    SELECT CASE LEN(X$)
     CASE 0: V$ = VD$
     CASE 1: V$ = ":"
     CASE 2: V$ = "\"
     CASE ELSE
      LB% = REVI%(X$, "\"): LD% = REVI%(X$, ".")
      IF LB% < LD% THEN
       IF LB% = 9 THEN V$ = ".\" ELSE V$ = VC$
       IF LB% > 1 THEN V$ = V$ + ".\"
      ELSE
       IF LD% = 4 THEN
        V$ = "\"
       ELSE
        IF LD% > 1 THEN V$ = VC$ + "\" ELSE V$ = VC$
       END IF
      END IF
    END SELECT
    IF INSTR(V$, IN$) > 0 AND LEN(X$) < 63 THEN
     X$ = X$ + IN$: PRINT IN$;
    ELSE
     SOUND 100, 1
    END IF
  END SELECT
 LOOP
END FUNCTION

FUNCTION DRIVES$  '** THANKS TO ANDREW GIBSON FOR THIS ROUT
 'Get current disk
 Regs.AX = &H1900                   'INT 21  AH 19h
 CALL Interrupt(&H21, Regs, Regs)   'Get current default drive
 C% = Regs.AX MOD 256               'Remember it
 'Get drive list
 FOR D% = 2 TO 25
  Regs.AX = &HE00: Regs.DX = D%     'INT 21  AH 0Eh
  CALL Interrupt(&H21, Regs, Regs)  'Set current default drive
  Regs.AX = &H1900                  'INT 21  AH 19h
  CALL Interrupt(&H21, Regs, Regs)  'Get current default drive
  'Append to list if DOS accepted this drive
  IF Regs.AX MOD 256 = D% THEN L$ = L$ + CHR$(65 + Regs.AX MOD 256)
 NEXT D%
 'Set original disk
 Regs.AX = &HE00: Regs.DX = C%      'INT 21  AH 0Eh
 CALL Interrupt(&H21, Regs, Regs)   'Set current default drive
 DRIVES$ = L$                       'Return drive list
END FUNCTION

FUNCTION FINPUT$ (VALID$, MLEN%, DEF$)
 DO
  IN$ = "": WHILE IN$ = "": IN$ = INKEY$: WEND
  SELECT CASE IN$
   CASE CHR$(8)
    IF LEN(X$) > 0 THEN
     X$ = LEFT$(X$, LEN(X$) - 1)
     LOCATE , POS(0) - 1: PRINT " ";
     LOCATE , POS(0) - 1
    END IF
   CASE CHR$(13)
    FINPUT$ = X$: EXIT FUNCTION
   CASE CHR$(27)
    FINPUT$ = CHR$(0): EXIT FUNCTION
   CASE ELSE
    IF LEN(IN$) = 1 THEN
     IN$ = UCASE$(IN$)
     IF INSTR(VALID$, IN$) > 0 THEN
      IF LEN(X$) < MLEN% THEN X$ = X$ + IN$: PRINT IN$;
     END IF
    END IF
  END SELECT
 LOOP
END FUNCTION

FUNCTION INSTALL%
 '** Initialize
 ERRX% = 0: CLS
 PRINT "MCD INSTALLATION!"
 PRINT
 PRINT "Looking for files..."

 '** Check for standard files
 PRINT "  Standard files - ";
 EXE% = 1: RESTORE EXE: READ T%, n%
 FOR n% = 1 TO T%
  READ F$
  ON ERROR GOTO FC
  OPEN F$ FOR INPUT AS #1: CLOSE #1
  ON ERROR GOTO UE
  IF ERRX% THEN EXE% = 0: ERRX% = 0
 NEXT n%
 IF EXE% = 0 THEN PRINT "not found" ELSE PRINT "found"

 '** Check for source files
 PRINT "  Source files - ";
 SRC% = 1: RESTORE SRC: READ T%, n%
 FOR n% = 1 TO T%
  READ F$
  ON ERROR GOTO FC
  OPEN F$ FOR INPUT AS #1: CLOSE #1
  ON ERROR GOTO UE
  IF ERRX% THEN SRC% = 0: ERRX% = 0
 NEXT n%
 IF SRC% = 0 THEN PRINT "not found" ELSE PRINT "found"

 '** Check for standard MPF
 PRINT "  Standard MPF - ";
 ON ERROR GOTO FC
 OPEN "MCD.MPF" FOR INPUT AS #1: CLOSE #1
 ON ERROR GOTO UE
 IF ERRX% THEN EPF% = 0: PRINT "not found": ERRX% = 0 ELSE EPF% = 1: PRINT "found"

 '** Check for source MPF
 PRINT "  Source MPF - ";
 ON ERROR GOTO FC
 OPEN "MCDSRC.MPF" FOR INPUT AS #1: CLOSE #1
 ON ERROR GOTO UE
 IF ERRX% THEN SPF% = 0: PRINT "not found": ERRX% = 0 ELSE SPF% = 1: PRINT "found"

 '** Display options
 PRINT : PRINT "Installation:"
 V$ = CHR$(27)
 IF EPF% = 1 THEN PRINT " a - extract standard MPF into new directory": V$ = V$ + "A"
 IF SPF% = 1 THEN PRINT " b - extract source MPF into new directory": V$ = V$ + "B"
 IF EXE% = 1 THEN PRINT " c - create/update standard MPF from existing files": V$ = V$ + "C"
 IF SRC% = 1 THEN PRINT " d - create/update source MPF from existing files": V$ = V$ + "D"
 IF V$ = CHR$(27) THEN PRINT "Nothing to do!": END
 PRINT " ESC aborts!"
 PRINT
 PRINT "Make a choise: ";

 '** Get input
 DO: IN$ = UCASE$(INKEY$): LOOP UNTIL INSTR(V$, IN$) > 0 AND IN$ <> ""
 IF IN$ <> CHR$(27) THEN PRINT IN$ ELSE PRINT "ESC"
 SELECT CASE IN$
  CASE "A", "B" '* Extract MPF
  
   '** Select file and get install path
   IF IN$ = "A" THEN F$ = "MCD" ELSE F$ = "MCDSRC"
   ID$ = DINPUT("Install to: ", "")
   PRINT
   IF ID$ = "" THEN PRINT "ABORTED!": END
   PRINT

   MKMD ID$

   '** Open MPF
   OPEN F$ + ".MPF" FOR BINARY ACCESS READ AS #1
  
   '** Get number of files
   GET #1, , A%: X$ = CHR$(0)
   FOR n% = 1 TO A%

    '** Get file name and print it
    X$ = CHR$(0): GET #1, , X$
    F$ = STRING$(ASC(X$), 0)
    GET #1, , F$: GET #1, , Z&
    PRINT F$, "o";

    '** Clear and open file
    OPEN ID$ + F$ FOR OUTPUT AS #2: CLOSE #2
    OPEN ID$ + F$ FOR BINARY ACCESS WRITE AS #2
   
    '** Copy
    X$ = STRING$(64, 0)
    DO
     IF Z& < 64 THEN X$ = STRING$(Z&, 0)
     GET #1, , X$: PUT #2, , X$
     X% = X% + 1: IF X% = 40 THEN X% = 1: PRINT "o";
     Z& = Z& - 64
    LOOP WHILE Z& > 0
    PRINT : CLOSE #2
   NEXT n%
   CLOSE #1
  CASE "C", "D" '* Create MPF
  
   'Select file, clear and open it
   IF IN$ = "C" THEN
    F$ = "MCD": RESTORE EXE
   ELSE
    F$ = "MCDSRC": RESTORE SRC
   END IF
   OPEN F$ + ".MPF" FOR OUTPUT AS #1: CLOSE #1
   OPEN F$ + ".MPF" FOR BINARY ACCESS WRITE AS #1

   '** Put number of files
   READ T%, C%: A% = T% + C%: PUT #1, , A%
   FOR n% = 1 TO T%
   
    '** Print, put and open file
    READ F$: PRINT F$, "o";
    X$ = CHR$(LEN(F$)) + F$: PUT #1, , X$
    OPEN F$ FOR BINARY ACCESS READ AS #2

    '** Get length and put
    Z& = LOF(2): PUT #1, , Z&

    '** Copy
    X$ = STRING$(64, 0)
    DO
     IF Z& < 64 THEN X$ = STRING$(Z&, 0)
     GET #2, , X$: PUT #1, , X$
     X% = X% + 1: IF X% = 40 THEN X% = 1: PRINT "o";
     Z& = Z& - 64
    LOOP WHILE Z& > 0
    PRINT : CLOSE #2
   NEXT n%

   '** Copy common files
   RESTORE CMN
   FOR n% = 1 TO C%
    READ F$, L&: PRINT F$, "o";
    X$ = CHR$(LEN(F$)) + F$: PUT #1, , X$
    PUT #1, , L&
    FOR Z& = 1 TO L&
     READ B%: X$ = CHR$(B%): PUT #1, , X$
    NEXT Z&
    PRINT
   NEXT n%
   CLOSE #1
 END SELECT
 END
END FUNCTION

FUNCTION MAIN% STATIC
 CLS
 CENTER 9, 12, "MCD SETUP!"
 CENTER 11, 14, "install player"
 CENTER 12, 14, "select screen mode"
 CENTER 13, 14, "color schemes"
 CENTER 14, 14, "save changes and quit!"
 CENTER 20, 9, "press escape to cancel all changes"
 BORDER 24, 32, 8, 8, 10
 COLOR 15
 DO
  LOCATE ROW% + 11, 27: PRINT "<"
  LOCATE ROW% + 11, 52: PRINT ">"
  IN$ = "": WHILE IN$ = "": IN$ = INKEY$: WEND
  LOCATE ROW% + 11, 27: PRINT " "
  LOCATE ROW% + 11, 52: PRINT " "
  SELECT CASE IN$
   CASE CHR$(0) + "H"
    IF ROW% > 0 THEN ROW% = ROW% - 1
   CASE CHR$(0) + "P"
    IF ROW% < 3 THEN ROW% = ROW% + 1
   CASE CHR$(13)
    MAIN% = ROW% + 1: EXIT FUNCTION
   CASE CHR$(27)
    MAIN% = 9: EXIT FUNCTION
  END SELECT
 LOOP
END FUNCTION

SUB MKMD (D$) '* MAKE MULTIPLE DIRECTORIES
 ON ERROR GOTO FC
 FOR n% = 4 TO LEN(D$)
  IF MID$(D$, n%, 1) = "\" THEN MKDIR LEFT$(D$, n% - 1)
 NEXT n%
 ON ERROR GOTO UE
END SUB

FUNCTION REVI% (S$, L$)
 FOR n% = LEN(S$) TO 1 STEP -1
  IF MID$(S$, n%, 1) = L$ THEN
   REVI% = 1 + LEN(S$) - n%
   EXIT FUNCTION
  END IF
 NEXT n%
 REVI% = LEN(S$) + 1
END FUNCTION

SUB SETPAL (A%, R%, G%, B%)
 OUT &H3C7, A%: OUT &H3C8, A%
 OUT &H3C9, R%: OUT &H3C9, G%: OUT &H3C9, B%
END SUB

SUB SMHPAL (F%, T%, FR%, FG%, FB%, TR%, TG%, TB%)
 TFD% = (T% - F%) - 1
 RD! = (TR% - FR%) / TFD%
 GD! = (TG% - FG%) / TFD%
 BD! = (TB% - FB%) / TFD%
 FOR n% = 0 TO TFD% + 1
  R% = INT(RD! * n%): G% = INT(GD! * n%): B% = INT(BD! * n%)
  SETPAL F% + n%, FR% + R%, FG% + G%, FB% + B%
 NEXT n%
END SUB

FUNCTION SMODE%
 CLS
 CENTER 9, 12, "SELECT SCREEN MODE!"
 CENTER 11, 14, "BIOS 320*200"
 CENTER 20, 9, "press escape to cancel selection"
 BORDER 24, 32, 8, 8, 10
 COLOR 15
 ROW% = SCRMOD%
 DO
  LOCATE ROW% + 11, 29: PRINT "<"
  LOCATE ROW% + 11, 50: PRINT ">"
  IN$ = "": WHILE IN$ = "": IN$ = INKEY$: WEND
  LOCATE ROW% + 11, 29: PRINT " "
  LOCATE ROW% + 11, 50: PRINT " "
  SELECT CASE IN$
   CASE CHR$(0) + "H"
    IF ROW% > 0 THEN ROW% = ROW% - 1
   CASE CHR$(0) + "P"
    IF ROW% < 0 THEN ROW% = ROW% + 1
   CASE CHR$(13)
    SCRMOD% = ROW%: SMODE% = 0: EXIT FUNCTION
   CASE CHR$(27)
    SMODE% = 0: EXIT FUNCTION
  END SELECT
 LOOP
END FUNCTION

